# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::LuisAuthoring::V3_0_preview
  module Models
    #
    # An application model info.
    #
    class ModelInfoResponse

      include MsRestAzure

      # @return The ID of the Entity Model.
      attr_accessor :id

      # @return [String] Name of the Entity Model.
      attr_accessor :name

      # @return [Integer] The type ID of the Entity Model.
      attr_accessor :type_id

      # @return [Enum] Possible values include: 'Entity Extractor', 'Child
      # Entity Extractor', 'Hierarchical Entity Extractor', 'Hierarchical Child
      # Entity Extractor', 'Composite Entity Extractor', 'List Entity
      # Extractor', 'Prebuilt Entity Extractor', 'Intent Classifier',
      # 'Pattern.Any Entity Extractor', 'Closed List Entity Extractor', 'Regex
      # Entity Extractor'
      attr_accessor :readable_type

      # @return [Array<EntityRole>]
      attr_accessor :roles

      # @return [Array<ChildEntity>] List of child entities.
      attr_accessor :children

      # @return [Array<SubClosedListResponse>] List of sublists.
      attr_accessor :sub_lists

      # @return [String] The domain name.
      attr_accessor :custom_prebuilt_domain_name

      # @return [String] The intent name or entity name.
      attr_accessor :custom_prebuilt_model_name

      # @return [String] The Regular Expression entity pattern.
      attr_accessor :regex_pattern

      # @return [Array<ExplicitListItem>]
      attr_accessor :explicit_list


      #
      # Mapper for ModelInfoResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ModelInfoResponse',
          type: {
            name: 'Composite',
            class_name: 'ModelInfoResponse',
            model_properties: {
              id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeId',
                type: {
                  name: 'Number'
                }
              },
              readable_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'readableType',
                type: {
                  name: 'String'
                }
              },
              roles: {
                client_side_validation: true,
                required: false,
                serialized_name: 'roles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EntityRoleElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EntityRole'
                      }
                  }
                }
              },
              children: {
                client_side_validation: true,
                required: false,
                serialized_name: 'children',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ChildEntityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ChildEntity'
                      }
                  }
                }
              },
              sub_lists: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subLists',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SubClosedListResponseElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'SubClosedListResponse'
                      }
                  }
                }
              },
              custom_prebuilt_domain_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'customPrebuiltDomainName',
                type: {
                  name: 'String'
                }
              },
              custom_prebuilt_model_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'customPrebuiltModelName',
                type: {
                  name: 'String'
                }
              },
              regex_pattern: {
                client_side_validation: true,
                required: false,
                serialized_name: 'regexPattern',
                type: {
                  name: 'String'
                }
              },
              explicit_list: {
                client_side_validation: true,
                required: false,
                serialized_name: 'explicitList',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ExplicitListItemElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ExplicitListItem'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
